tech.lgbt is one of the many independent Mastodon servers you can use to participate in the fediverse.
We welcome all marginalized identities. This Mastodon instance is generally for folks who are LGBTQIA+ and Allies with an interest in tech work, academics, or technology in general.

Server stats:

2.9K
active users

Public

Good news: I have managed to solve part 1 of Day 3 of , and part 2 is now running.

Given my chosen language has quirks like not being able to easily read more than 260 characters in an input line (where my actual input has >3k) and not having a performant string search algorithm built-in, it's not that surprising I'm a few days behind.

Quiet public

Part 2 just finished computing, and was correct!

Hopefully the rest of the puzzles don't rub my language the wrong way quite so much as this one did.

Public

More good news: I have gotten out part 1 of day 5 of , despite my language's attempts to silently truncate the comma separated list of numbers in my input to 10 items.

I don't think my structure makes part 2 that much more difficult, but that's a tomorrow problem.

Public

Part 2 of day 6 of is being a little tricky, because I've backed myself into a corner where my I have an O(MN) algorithm. I've managed to reduce M so it grows slower than N, but this all would have been avoided if I'd just thrown more memory at the problem or implemented a hash table.

Took a quick look ahead at day 7, and it looks like we've got >32bit integers, which is also tricky, but I think I can reuse some old code for that.

Quiet public

Well, it's the wrong answer, so I guess I'll have to rewrite it anyway to be able to have a functional debugging feedback cycle. ¯_(ツ)_/¯

Quiet public

Rewrote a substantial part of it and now have part 2 of day 6 solved! \o/

Public

Spent a substantial amount of time yesterday implementing a weird integer type (uint64 + a sign bit, that probably takes up 24 bytes of memory), along with base-10 parsing, fast conversion from builtin int32s, addition, multiplication (which is much slower than I'd like) and comparison.

My first strategy for part 1 of day 7 was very slow to run, so I tried to add some short-circuits, but didn't get the logic quite right there, so got the wrong answer. Went back to the drawing board and found a better way of approaching the problem using a stack. Unfortunately, the obvious way of putting my integer type into the stack leads to a landmine of language implementation bugs that should be impossible, so it again took a while to figure out how to redesign things to avoid that problem.

Anyhow, it's running now, and I should get an answer out in 20m or so. (I already wrote an independent implementation of my approach which got the correct answer)

Public

Part 1 came out fine, but it took more like an hour to run (this is merely implementation issues, the same algorithm in Python takes < 1s).

I thought Part 2 would need me to implement base 10 rendering or division for my cursed integer type, but then I realised if I just defined 10, 100, 1000, … as constants, I could write something that would work for what I needed.

Unfortunately, my estimate is that my implementation of Part 2 has ~32x base operations as Part 1, so yeah, I guess I'll move onto Day 8 while that's running.

Public

Day 8 of was uneventful, since I had binary search and COUNT DISTINCT from earlier problems.

Alas, Day 9 posed more challenges, since (a) the input has more characters in a line than previously seen; and (b) the naive way of turning those characters into digits had utterly awful performance. So I spent a bunch of time writing some specialised code, and then moved onto the actual problem. Part 1 was not too difficult, but I failed to think about the size of the answer, which fortunately made my int32 negative, so some judicious wrapping with my cursed integer type was necessary to get the right answer (with some performance cost).

I have a plan for Part 2, but I think I have exhausted my coding ability for tonight.

Public

Finally managed to get part 2 of day 9 of working with a binary heap and a performance improvement to sorting with custom comparators.

Also added some utility functions for debugging so I don't have to keep commenting/uncommenting bits of code.

Public

Spent the day catching up on .

I read part 1 of day 10 wrong the first time, and started designing a clever solution for it before realising it was a lot simpler than that. Conveniently, part 2 was what I had incorrectly assumed part 1 was.

I suspect that the optimisation I did to part 1 of day 11 was what most people needed to do to get part 2 working, so my part 2 is still running ☹. Maybe I’ll actually drop a layer of abstraction to make my integer operations fast (which would help with part 2 of day 7, which I haven't yet has a successful run for).

Public

My language has reasonable performance for sorting lists of numbers, but not for sorting anything more complicated than that, which means a common pattern has been encoding (x, y) as y*width+x (and whenever I need to add a direction to that, (y*width+x)*4+d). So far I haven't needed a tree or hash map—sort then do many binary searches is the common pattern—but I’m pretty sure I’ll end up implementing at least one of these (oh, does your language have them built in? how quaint.)

Quiet public

…and part 2 of day 12 is correct. 😃

Public

Day 13 of had two obvious solutions (brute force and do some maths), and so I did the maths for Part 1, which worked out quite nicely. Unfortunately, Part 2 introduced some bigger numbers, and my cursed integer type was not up to the job.

So now I have an implementation of arbitrary precision integer arithmetic with operators +-*/<>=, str and parse (in a language that has i32 but not u32). Division was the hardest part, I may have exclaimed "praise be to Knuth" at some point during this foolish endeavour.

Anyhow, Part 2 is done now.

Public

Now up to Day 14 of : I took the easy approach for part 1, though I didn't carefully check my integer bounds, but it turned out to work just fine.

Part 2 was much more interesting: how am I meant to do image recognition on the robot positions?! But I reduced this down to "find an arrangement where lots of robots are together", which invited the following heuristic: if we put all the robot positions on a space-filling curve, then the length of the longest run of consecutive positions should be higher when lots of robots are together.

Found github.com/jakubcerveny/gilbert to give me a space-filling curve for the 101×103 grid, which I turned into an array of 10403 numbers, where indexing by y*103+x gives the position on the curve.

GitHubGitHub - jakubcerveny/gilbert: Space-filling curve for rectangular domains or arbitrary size.Space-filling curve for rectangular domains or arbitrary size. - jakubcerveny/gilbert
Quiet public

Two problems: I still need a threshold for the run length (I arbitrarily chose 10), and my implementation is slow. But I coded up the same algorithm in Python (which ran ~instantly), and it turns out my heuristic is very effective: most steps give a value ≤4, and then the correct step gives 79.

Public

Made more progress up to Part 1 of Day 17 of .

But now I'm heading back to Part 2 of Day 7, which was lacking in performance. I've switched it to my bignum type, which has let me implement some algorithm improvements, and now it gives a correct answer in < 1h. \o/

Public

Spent the evening wiring the first 10 days together, and now you can "play" a prerelease of my solution for 2024 at static.flowblok.id.au/pub/aoc2

This is a Glulx game implemented with Inform 7, which I used for Day 5 of 2023 (write-up: blog.flowblok.id.au/2024-03/ad).

Public

With the exception of Part 2 of Day 17 (which I've skipped because it looks rather involved, particularly when you lack bitwise operators), I now have everything up to Day 20 of published (static.flowblok.id.au/pub/aoc2)

(disclaimer: many of the solutions will be sloooow to run, and are not resilient to bad inputs)

static.flowblok.id.auflowblok - Advent of Code 2024 — Play
Quiet public

Published another update, with everything except Part 2 of Days 17, 21, 23 and 24.

Quiet public

The performance for Part 2 of Day 23 is terrible[1], but I have gotten the correct answer.

[1] I have discovered that not only does my list type lack amortized constant time append, it's also built on top of a linked list, though in a way that I don't yet have a good mental model for.

Quiet public

Part 2 of Day 21 is also out, but then I went to release it and discovered it was too big for the JS interpreter to handle. I'd also noticed it had gotten rather slow to compile…

I’ve now reduced this down to a minimal test case, and I (proudly? shamefully?) present inform7.atlassian.net/browse/I.

inform7.atlassian.netJira
Quiet public

Ugh, forgot that requires login just to view, so here's a screenshot.

Almost there, just have Part 2 of Day 24 left. I have two ideas for how to go about it, but my brain is done for today, so I'm going to add some cosmetic touches and then go play games.

Quiet public

I’ve been writing this up as a blog post, except I got to multiplication, realised there’s a faster way to do one of the steps, and now Part 1 of Day 7 runs almost 5x faster. Oops.